# feewee-erp-frame
`feewee` 科技-前端ERP集成框架。


**authors:**
+ [vuchan](https://github.com/vuchan)
+ [fw-fe-erp-team](http://gitlab.feewee.cn/groups/front/group_members)


## TODO
1. [x] 路由404/405/500匹配
2. [x] 菜单匹配并自动展开
3. [x] ES6 => ES5
4. [ ] [styled-components](https://www.styled-components.com/)
5. [ ] 隔离当前模块的 CSS module


# How to update this package?
首先，更新下面的`ChangeLog`，新增版本修改记录和修改内容。
其次，发布这个包。在发布时候，确保你的 npm `registry` 指向的源是 `https://registry.npmjs.org/`。
获取 npm 源的 npm command:
```bash
npm config get registry
```

发布这个包
```bash
npm run publish
```

如果你使用`cnpm`且需要立即使用的话(使用`cnpm`立即同步`npm`服务器)：
```bash
cnpm sync feewee
```


## ChangeLog

`v1.1.3`: @author vuchan
  + 集成 `axios`, `dva`, `antd-pro`, `antd`
  + 集成 `http`,
  + 集成 `utils`

`v1.1.4`: @author vuchan
  + 增加 `feewee/assets` 文件
  + 修复 `antd` 组件引入的样式问题
  + 增加 `container` 组件
  + 增加 `RouteContainer` 组件
  + 增加 `utils` 中 `isPlainObject`, `isUrl`, `isPhoneNumber` @type checker 方法
  + 增强 `utils` 中 `getQueryString` 方法

`v1.1.5`: @author vuchan
  + 修复路由无法被`react-router`识别的问题
  + 暂停`react-loadable`的懒加载支持

`v1.2.0`: @author vuchan
  + 修复路由跳转、切换和匹配错误
  + 增加`outerRoutes`功能
  + 增强`Cookie`功能
  + 增强`Axios`功能，支持`axios.postForm`&`axios.postJSON`
  + 增加`403`,`404`,`500`路由
  + 增加`ShopList`组件
  + 修复`localMenus` on works under `development` env.
  + 增加`babel`本地`build``lib`功能

`^v1.3.3`: @author vuchan
  + 修复`CSS`在`dva->roadhog->af-webpack`中不工作
    [af-webpack/getConfig](https://github.com/umijs/umi/blob/master/packages/af-webpack/src/getConfig/css.js#L174)的设置
中，`/node_modules/**/*.less`在`/node_modules/`文件下的内容默认`cssModules`是false，虽然开源通过`webpack.config.js`文件自定义配置，但是如果你在配置中依赖了其他文件的`.less`，或者你使用内置`.less`文件，依然会出问题。非常奇怪！！！！
    所以不得不用非常不优雅，非常鸡肋和麻烦的做法，先将LESS文件用`less`+`CSS+namespace`的方式写出，然后编译成`.CSS`文件给`*.js`中`component`使用。。。
    因此，长个记性。难道是因为通用规则是将`npm`中`lib`下的`less`都用原生CSS。？？？`antd`是这样做的。
    而如果不放进`node_modules`准确说是`npm`则不会出问题！！！

`v1.3.4`: @author vuchan
  + 修复不同系统间跳转错误，以及登出界面时候跳转错误
  + 修复`getQueryString`返回`null`

`v1.3.5`: @author vuchan
  + 修复输入`HOST`时，路径被拼了几层的`redirect`，通过新增`components/RefreshRoutes`解决
  + 修复`http`中`axios`的挂载方法`postForm/postJSON`request header头中`Content-Type`错误

`v1.3.6`: @author suchu
  + deprecated version
 
`v1.3.7`: @author suchu
   + idem 😂 
   
`v1.3.8`: @author suchu
  + 修正response拦截器的逻辑，(`success===true && code !===0`)
  
## feewee/http

提供基于框架层和后端接口的框架层处理。
  + 提供http状态码异常处理
  + 提供业务逻辑错误处理

TODO:
  + 设计 `http token`， `MAC + TimeStamp + Math.random()`


## feewee/components

  + [components](./components)
  + 提供 `Container` 组件，它提供基础布局内容，包括`Drawer -> SiderMenu`，`Header`。
  + 集成 `antd-pro` 基本布局
  + `export default BasicLayout`


## feewee/global
`global`提供公用逻辑的脚本和常量。


### feewee/global/router
  + 存放公共 `global` 的 `router`
  + 基于 `dva` 的 `app.router`


### feewee/global/const
  + 存放公共 `global` 的 `constants`


### feewee/global/model
  + 存放公共 `global` 的`model`


### feewee/global/services
  + 存放公共 `global` 的`services`


## feewee/utils
  + 实现诸多 `utils` 的方法
  + 参加 `utils` 文件内的 `README.md`

TODO:
  + 实现类似`rollbar`的错误监控系统，监听错误和`bug`的发生。


## NOTE

英语不好。语法错误，还请见谅。

## For next maintainer

有什么问题，欢迎联系我。Good luck.
