"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _keys = _interopRequireDefault(require("@babel/runtime/core-js/object/keys"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _dva = require("dva");

var _enquireJs = require("enquire-js");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _pathToRegexp = _interopRequireDefault(require("path-to-regexp"));

var _reactDocumentTitle = _interopRequireDefault(require("react-document-title"));

var _reactContainerQuery = require("react-container-query");

var _antd = require("antd");

var _const = require("../../global/const");

var _GlobalHeader = _interopRequireDefault(require("../GlobalHeader"));

var _GlobalFooter = _interopRequireDefault(require("../GlobalFooter"));

var _SiderMenu = _interopRequireDefault(require("../SiderMenu"));

var _utils = require("../../utils");

var _utils2 = require("../../global/router/utils");

var _spin = _interopRequireDefault(require("antd/lib/spin"));

require("antd/lib/spin/style/css");

var _logo = _interopRequireDefault(require("../../assets/logo.png"));

var _dec, _class, _class2, _temp2;

var Content = _antd.Layout.Content,
    Header = _antd.Layout.Header,
    Footer = _antd.Layout.Footer;
var fullPageCenter = {
  position: 'relative',
  display: 'flex',
  alignItems: 'center',
  justifyContent: 'center',
  width: '100%',
  height: '100%'
};
var isMobile = false;
/**
 * 避免服务端渲染报错。
 * https://www.npmjs.com/package/enquire-js
 * https://github.com/jljsj/enquire-js#readme
 * https://www.npmjs.com/package/enquire
 */

(0, _enquireJs.enquireScreen)(function (b) {
  // if mobileQuery = 'only screen and (max-width: 767.99px)' so is mobile;
  isMobile = b;
});
var Container = (_dec = (0, _dva.connect)(function (_ref) {
  var menus = _ref.global.menus,
      loading = _ref.loading;
  return {
    menus: menus,
    switchLoading: loading.effects['global/switch']
  };
}), _dec(_class = (_temp2 = _class2 =
/*#__PURE__*/
function (_React$PureComponent) {
  function Container() {
    var _getPrototypeOf2;

    var _temp, _this;

    (0, _classCallCheck2.default)(this, Container);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2.default)(_this, (_temp = _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(Container)).call.apply(_getPrototypeOf2, [this].concat(args))), (0, _defineProperty2.default)((0, _defineProperty2.default)((0, _defineProperty2.default)((0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "state", {
      collapsed: false,
      isMobile: isMobile,
      routerData: {} // Export Context API

    }), "mergeRouterWithMenu", function (menus) {
      var _this$props = _this.props,
          routers = _this$props.routers,
          localMenus = _this$props.localMenus; // merge menus with

      var flattenedMenus = (0, _utils2.flattenChildren)((0, _utils2.getMenuData)(menus, localMenus));
      var routerData = {};
      routers && flattenedMenus.forEach(function (item) {
        var router = routers[item.path];

        if (router) {
          routerData[item.path] = (0, _objectSpread2.default)({}, item, router);
        }
      });

      _this.setState({
        routerData: routerData
      });
    }), "handleMenuCollapse", function (collapsed) {
      _this.setState({
        collapsed: collapsed
      });
    }), "handleMenuClick", function (_ref2) {
      var key = _ref2.key;
      var _this$props2 = _this.props,
          dispatch = _this$props2.dispatch,
          redirect = _this$props2.redirect;

      if (key === 'logout') {
        dispatch({
          type: 'global/logout',
          payload: redirect
        });
      }
    }), _temp));
  }

  (0, _createClass2.default)(Container, [{
    key: "getChildContext",
    value: function getChildContext() {
      var routerData = this.state.routerData;
      var location = this.props.location;
      return {
        location: location,
        routerData: routerData // breadcrumbNameMap: getBreadcrumbNameMap(getMenuData(), routerData),

      };
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      this.enquireHandler = (0, _enquireJs.enquireScreen)(function (mobile) {
        _this2.setState({
          isMobile: mobile
        });
      });
      var _this$props3 = this.props,
          history = _this$props3.history,
          dispatch = _this$props3.dispatch;
      this.clearHistoryListener = history.listen(function () {
        _this2.genePageTitle();
      });
      dispatch({
        type: 'global/fetchMenu'
      });
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (this.props.menus && (!this.props.menus || (this.props.menus && this.props.menus.length) !== nextProps.menus.length)) {
        this.mergeRouterWithMenu(nextProps.menus);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      (0, _enquireJs.unenquireScreen)(this.enquireHandler);
      this.clearHistoryListener();
    }
  }, {
    key: "genePageTitle",
    value: function genePageTitle() {
      var routerData = this.state.routerData;
      var _this$props4 = this.props,
          switchLoading = _this$props4.switchLoading,
          propTitle = _this$props4.title,
          location = _this$props4.location;
      if (switchLoading) return '切换门店中';
      var title = propTitle || _const.TITLE;

      if (location && routerData) {
        var pathname = location.pathname;
        var currRouterData = null; // match params path

        (0, _keys.default)(routerData).forEach(function (key) {
          if ((0, _pathToRegexp.default)(key).test(pathname)) {
            currRouterData = routerData[key];
          }
        });

        if (currRouterData && currRouterData.name) {
          title = "".concat(currRouterData.name, "-").concat(_const.TITLE);
        }
      }

      return title;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state = this.state,
          collapsed = _this$state.collapsed,
          mb = _this$state.isMobile;
      var _this$props5 = this.props,
          switchLoading = _this$props5.switchLoading,
          menus = _this$props5.menus,
          localMenus = _this$props5.localMenus,
          location = _this$props5.location;

      var layout = _react.default.createElement(_antd.Layout, null, // 必须等待 menus 加载完毕 因为 SiderMenu 中的逻辑依赖了 menus && menus.length
      _react.default.createElement(_SiderMenu.default, {
        logo: _logo.default,
        title: _const.TITLE.slice(0, -2),
        menuData: (0, _utils2.getMenuData)(menus, localMenus) // 整合本地menus 或者即开发环境下的假菜单😊
        ,
        collapsed: collapsed,
        location: location,
        isMobile: Boolean(mb),
        onCollapse: this.handleMenuCollapse
      }), _react.default.createElement(_antd.Layout, null, _react.default.createElement(Header, {
        style: {
          padding: 0
        }
      }, _react.default.createElement(_GlobalHeader.default, {
        logo: _logo.default,
        collapsed: collapsed,
        isMobile: Boolean(mb),
        onCollapse: this.handleMenuCollapse,
        onMenuClick: this.handleMenuClick
      })), _react.default.createElement(Content, {
        style: {
          margin: '24px 24px 0',
          height: '100%'
        }
      }, this.props.children), _react.default.createElement(Footer, {
        style: {
          padding: 0
        }
      }, _react.default.createElement(_GlobalFooter.default, {
        copyright: _react.default.createElement(_react.Fragment, null, "Copyright ", _react.default.createElement(_antd.Icon, {
          type: "copyright"
        }), " ", _const.COPYRIGHT)
      }))));

      return _react.default.createElement(_reactDocumentTitle.default, {
        title: this.genePageTitle()
      }, switchLoading ? _react.default.createElement("div", {
        style: fullPageCenter
      }, _react.default.createElement(_spin.default, {
        spinning: Boolean(switchLoading),
        tip: "\u5207\u6362\u8D26\u53F7\u4E2D"
      })) : _react.default.createElement(_reactContainerQuery.ContainerQuery, {
        query: _const.MEDIA_QUERY
      }, function (params) {
        return _react.default.createElement("div", {
          className: (0, _utils.classNames)(params)
        }, layout);
      }));
    }
  }]);
  (0, _inherits2.default)(Container, _React$PureComponent);
  return Container;
}(_react.default.PureComponent), (0, _defineProperty2.default)(_class2, "childContextTypes", {
  location: _propTypes.default.object,
  routerData: _propTypes.default.object // breadcrumbNameMap: PropTypes.object,

}), _temp2)) || _class);
exports.default = Container;