"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.cutStrByFullLength = exports.getStrFullLength = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _classnames = _interopRequireDefault(require("classnames"));

require("./index.module.css");

/* eslint react/no-did-mount-set-state: 0 */

/* eslint no-param-reassign: 0 */
var isSupportLineClamp = document.body.style.webkitLineClamp !== undefined;
var TooltipOverlayStyle = {
  overflowWrap: 'break-word',
  wordWrap: 'break-word'
};

var getStrFullLength = function getStrFullLength() {
  var str = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return str.split('').reduce(function (pre, cur) {
    var charCode = cur.charCodeAt(0);

    if (charCode >= 0 && charCode <= 128) {
      return pre + 1;
    } else {
      return pre + 2;
    }
  }, 0);
};

exports.getStrFullLength = getStrFullLength;

var cutStrByFullLength = function cutStrByFullLength() {
  var str = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var maxLength = arguments.length > 1 ? arguments[1] : undefined;
  var showLength = 0;
  return str.split('').reduce(function (pre, cur) {
    var charCode = cur.charCodeAt(0);

    if (charCode >= 0 && charCode <= 128) {
      showLength += 1;
    } else {
      showLength += 2;
    }

    if (showLength <= maxLength) {
      return pre + cur;
    } else {
      return pre;
    }
  }, '');
};

exports.cutStrByFullLength = cutStrByFullLength;

var EllipsisText = function EllipsisText(_ref) {
  var text = _ref.text,
      length = _ref.length,
      tooltip = _ref.tooltip,
      fullWidthRecognition = _ref.fullWidthRecognition,
      other = (0, _objectWithoutProperties2.default)(_ref, ["text", "length", "tooltip", "fullWidthRecognition"]);

  if (typeof text !== 'string') {
    throw new Error('Ellipsis children must be string.');
  }

  var textLength = fullWidthRecognition ? getStrFullLength(text) : text.length;

  if (textLength <= length || length < 0) {
    return _react.default.createElement("span", other, text);
  }

  var tail = '...';
  var displayText;

  if (length - tail.length <= 0) {
    displayText = '';
  } else {
    displayText = fullWidthRecognition ? cutStrByFullLength(text, length) : text.slice(0, length);
  }

  if (tooltip) {
    return _react.default.createElement(_antd.Tooltip, {
      overlayStyle: TooltipOverlayStyle,
      title: text
    }, _react.default.createElement("span", null, displayText, tail));
  }

  return _react.default.createElement("span", other, displayText, tail);
};

var Ellipsis =
/*#__PURE__*/
function (_Component) {
  function Ellipsis() {
    var _getPrototypeOf2;

    var _temp, _this;

    (0, _classCallCheck2.default)(this, Ellipsis);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2.default)(_this, (_temp = _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(Ellipsis)).call.apply(_getPrototypeOf2, [this].concat(args))), (0, _defineProperty2.default)((0, _defineProperty2.default)((0, _defineProperty2.default)((0, _defineProperty2.default)((0, _defineProperty2.default)((0, _defineProperty2.default)((0, _defineProperty2.default)((0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "state", {
      text: '',
      targetCount: 0
    }), "computeLine", function () {
      var lines = _this.props.lines;

      if (lines && !isSupportLineClamp) {
        var text = _this.shadowChildren.innerText;
        var lineHeight = parseInt(getComputedStyle(_this.root).lineHeight, 10);
        var targetHeight = lines * lineHeight;
        _this.content.style.height = "".concat(targetHeight, "px");
        var totalHeight = _this.shadowChildren.offsetHeight;
        var shadowNode = _this.shadow.firstChild;

        if (totalHeight <= targetHeight) {
          _this.setState({
            text: text,
            targetCount: text.length
          });

          return;
        } // bisection


        var len = text.length;
        var mid = Math.ceil(len / 2);

        var count = _this.bisection(targetHeight, mid, 0, len, text, shadowNode);

        _this.setState({
          text: text,
          targetCount: count
        });
      }
    }), "bisection", function (th, m, b, e, text, shadowNode) {
      var suffix = '...';
      var mid = m;
      var end = e;
      var begin = b;
      shadowNode.innerHTML = text.substring(0, mid) + suffix;
      var sh = shadowNode.offsetHeight;

      if (sh <= th) {
        shadowNode.innerHTML = text.substring(0, mid + 1) + suffix;
        sh = shadowNode.offsetHeight;

        if (sh > th) {
          return mid;
        } else {
          begin = mid;
          mid = Math.floor((end - begin) / 2) + begin;
          return _this.bisection(th, mid, begin, end, text, shadowNode);
        }
      } else {
        if (mid - 1 < 0) {
          return mid;
        }

        shadowNode.innerHTML = text.substring(0, mid - 1) + suffix;
        sh = shadowNode.offsetHeight;

        if (sh <= th) {
          return mid - 1;
        } else {
          end = mid;
          mid = Math.floor((end - begin) / 2) + begin;
          return _this.bisection(th, mid, begin, end, text, shadowNode);
        }
      }
    }), "handleRoot", function (n) {
      _this.root = n;
    }), "handleContent", function (n) {
      _this.content = n;
    }), "handleNode", function (n) {
      _this.node = n;
    }), "handleShadow", function (n) {
      _this.shadow = n;
    }), "handleShadowChildren", function (n) {
      _this.shadowChildren = n;
    }), _temp));
  }

  (0, _createClass2.default)(Ellipsis, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.node) {
        this.computeLine();
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var lines = this.props.lines;

      if (lines !== nextProps.lines) {
        this.computeLine();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;

      var _this$state = this.state,
          text = _this$state.text,
          targetCount = _this$state.targetCount;
      var _this$props = this.props,
          children = _this$props.children,
          lines = _this$props.lines,
          length = _this$props.length,
          className = _this$props.className,
          tooltip = _this$props.tooltip,
          fullWidthRecognition = _this$props.fullWidthRecognition,
          restProps = (0, _objectWithoutProperties2.default)(_this$props, ["children", "lines", "length", "className", "tooltip", "fullWidthRecognition"]);
      var cls = (0, _classnames.default)("ellipsis", className, (_classNames = {}, (0, _defineProperty2.default)(_classNames, "lines", lines && !isSupportLineClamp), (0, _defineProperty2.default)(_classNames, "lineClamp", lines && isSupportLineClamp), _classNames));

      if (!lines && !length) {
        return _react.default.createElement("span", (0, _extends2.default)({
          className: cls
        }, restProps), children);
      } // length


      if (!lines) {
        return _react.default.createElement(EllipsisText, (0, _extends2.default)({
          className: cls,
          length: length,
          text: children || '',
          tooltip: tooltip,
          fullWidthRecognition: fullWidthRecognition
        }, restProps));
      }

      var id = "antd-pro-ellipsis-".concat("".concat(new Date().getTime()).concat(Math.floor(Math.random() * 100))); // support document.body.style.webkitLineClamp

      if (isSupportLineClamp) {
        var style = "#".concat(id, "{-webkit-line-clamp:").concat(lines, ";-webkit-box-orient: vertical;}");
        return _react.default.createElement("div", (0, _extends2.default)({
          id: id,
          className: cls
        }, restProps), _react.default.createElement("style", null, style), tooltip ? _react.default.createElement(_antd.Tooltip, {
          overlayStyle: TooltipOverlayStyle,
          title: children
        }, children) : children);
      }

      var childNode = _react.default.createElement("span", {
        ref: this.handleNode
      }, targetCount > 0 && text.substring(0, targetCount), targetCount > 0 && targetCount < text.length && '...');

      return _react.default.createElement("div", (0, _extends2.default)({}, restProps, {
        ref: this.handleRoot,
        className: cls
      }), _react.default.createElement("div", {
        ref: this.handleContent
      }, tooltip ? _react.default.createElement(_antd.Tooltip, {
        overlayStyle: TooltipOverlayStyle,
        title: text
      }, childNode) : childNode, _react.default.createElement("div", {
        className: "shadow",
        ref: this.handleShadowChildren
      }, children), _react.default.createElement("div", {
        className: "shadow",
        ref: this.handleShadow
      }, _react.default.createElement("span", null, text))));
    }
  }]);
  (0, _inherits2.default)(Ellipsis, _Component);
  return Ellipsis;
}(_react.Component);

exports.default = Ellipsis;