"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.urlToList = urlToList;
exports.getHash = getHash;
exports.default = exports.getMenuMatchKeys = exports.getFlatMenuKeys = exports.getIcon = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _pathToRegexp = _interopRequireDefault(require("path-to-regexp"));

var _router = require("dva/router");

var _ShopList = _interopRequireDefault(require("../ShopList"));

var _menu = _interopRequireDefault(require("antd/lib/menu"));

require("antd/lib/menu/style/css");

var _icon = _interopRequireDefault(require("antd/lib/icon"));

require("antd/lib/icon/style/css");

var _layout = _interopRequireDefault(require("antd/lib/layout"));

require("antd/lib/layout/style/css");

require("./index.module.css");

var Sider = _layout.default.Sider;
var SubMenu = _menu.default.SubMenu; // Allow menu.js config icon as string or ReactNode
//   icon: 'setting',
//   icon: 'http://demo.com/icon.png',
//   icon: <Icon type="setting" />,

var getIcon = function getIcon(icon) {
  if (typeof icon === 'string' && icon.indexOf('http') === 0) {
    return _react.default.createElement("img", {
      src: icon,
      alt: "icon",
      className: "menu-icon".concat(" sider-menu-item-img")
    });
  }

  if (typeof icon === 'string') {
    return _react.default.createElement(_icon.default, {
      type: icon
    });
  }

  return icon;
}; // /userinfo/2144/id => ['/userinfo','/useinfo/2144,'/userindo/2144/id']


exports.getIcon = getIcon;

function urlToList(url) {
  var urlList = url.split('/').filter(function (i) {
    return i;
  });
  return urlList.map(function (
  /* urlItem */
  _, index) {
    return "/".concat(urlList.slice(0, index + 1).join('/'));
  });
}

function getHash(item) {
  var path = item.path;

  if (/^https?:\/\//.test(path)) {
    var url = new URL(path);
    return url.hash ? url.hash.replace(/^\#/, '') : item.path;
  }

  return path;
}
/**
 * Recursively flatten the data
 * [{path:string},{path:string}] => {path,path2}
 * @param  menu
 */


var getFlatMenuKeys = function getFlatMenuKeys(menu) {
  return menu && menu.reduce(function (keys, item) {
    keys.push(getHash(item));

    if (item.children) {
      return keys.concat(getFlatMenuKeys(item.children));
    }

    return keys;
  }, []);
};
/**
 * Find all matched menu keys based on paths
 * @param  flatMenuKeys: [/abc, /abc/:id, /abc/:id/info]
 * @param  paths: [/abc, /abc/11, /abc/11/info]
 */


exports.getFlatMenuKeys = getFlatMenuKeys;

var getMenuMatchKeys = function getMenuMatchKeys(flatMenuKeys, paths) {
  return paths.reduce(function (matchKeys, path) {
    return matchKeys.concat(flatMenuKeys.filter(function (item) {
      return (0, _pathToRegexp.default)(item).test(path);
    }));
  }, []);
};

exports.getMenuMatchKeys = getMenuMatchKeys;

var SiderMenu =
/*#__PURE__*/
function (_React$Component) {
  function SiderMenu(props) {
    var _this;

    (0, _classCallCheck2.default)(this, SiderMenu);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(SiderMenu).call(this, props));
    (0, _defineProperty2.default)((0, _defineProperty2.default)((0, _defineProperty2.default)((0, _defineProperty2.default)((0, _defineProperty2.default)((0, _defineProperty2.default)((0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "getMenuItemPath", function (item) {
      var itemPath = _this.conversionPath(item.path);

      var icon = getIcon(item.icon);
      var target = item.target,
          name = item.name; // Is it a http link

      if (/^https?:\/\//.test(itemPath)) {
        return _react.default.createElement("a", {
          href: itemPath,
          target: target
        }, icon, _react.default.createElement("span", null, name));
      }

      var _this$props = _this.props,
          location = _this$props.location,
          isMobile = _this$props.isMobile,
          onCollapse = _this$props.onCollapse;
      return _react.default.createElement(_router.Link, {
        to: itemPath,
        target: target,
        replace: itemPath === location.pathname,
        onClick: isMobile ? function () {
          onCollapse(true);
        } : undefined
      }, icon, _react.default.createElement("span", null, name));
    }), "getSubMenuOrItem", function (item) {
      if (item.children && item.children.some(function (child) {
        return child.name;
      })) {
        var childrenItems = _this.getNavMenuItems(item.children); // 当无子菜单时就不展示菜单


        if (childrenItems && childrenItems.length > 0) {
          var title = item.icon ? _react.default.createElement("span", null, getIcon(item.icon), _react.default.createElement("span", null, item.name)) : item.name;
          return _react.default.createElement(SubMenu, {
            key: item.path,
            title: title
          }, childrenItems);
        }

        return null;
      } else {
        return _react.default.createElement(_menu.default.Item, {
          key: getHash(item)
        }, _this.getMenuItemPath(item));
      }
    }), "getNavMenuItems", function (menusData) {
      if (!menusData) {
        return [];
      }

      return menusData.filter(function (item) {
        return item.name && !item.hideInMenu;
      }).map(function (item) {
        return _this.getSubMenuOrItem(item);
      }).filter(function (item) {
        return item;
      });
    }), "getSelectedMenuKeys", function () {
      var pathname = _this.props.location.pathname;
      return getMenuMatchKeys(_this.flatMenuKeys, urlToList(pathname));
    }), "conversionPath", function (path) {
      if (path && path.indexOf('http') === 0) {
        return path;
      } else {
        return "/".concat(path || '').replace(/\/+/g, '/');
      }
    }), "isMainMenu", function (key) {
      return _this.menus.some(function (item) {
        return key && (item.key === key || item.path === key);
      });
    }), "handleOpenChange", function (openKeys) {
      var lastOpenKey = openKeys[openKeys.length - 1];
      var moreThanOne = openKeys.filter(function (openKey) {
        return _this.isMainMenu(openKey);
      }).length > 1;

      _this.setState({
        openKeys: moreThanOne ? [lastOpenKey] : (0, _toConsumableArray2.default)(openKeys)
      });
    });
    _this.menus = props.menuData;
    _this.flatMenuKeys = getFlatMenuKeys(props.menuData);
    _this.state = {
      openKeys: _this.getDefaultCollapsedSubMenus(props) // openKeys	当前展开的 SubMenu 菜单项 key 数组	string[]

    };
    return _this;
  }

  (0, _createClass2.default)(SiderMenu, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var location = this.props.location;

      if (nextProps.location.pathname !== location.pathname || this.props.menuData && (!this.props.menuData || this.props.menuData.length) !== nextProps.menuData.length) {
        this.menus = nextProps.menuData;
        this.flatMenuKeys = getFlatMenuKeys(nextProps.menuData);
        this.setState({
          openKeys: this.getDefaultCollapsedSubMenus(nextProps)
        });
      }
    }
    /**
     * Convert pathname to openKeys
     * /list/search/articles = > ['list','/list/search']
     * @param  props
     */

  }, {
    key: "getDefaultCollapsedSubMenus",
    value: function getDefaultCollapsedSubMenus(props) {
      var _ref = props || this.props,
          pathname = _ref.location.pathname;

      return getMenuMatchKeys(this.flatMenuKeys, urlToList(pathname));
    }
    /**
     * 判断是否是http链接.返回 Link 或 a
     * Judge whether it is http link.return a or Link
     * @memberof SiderMenu
     */

  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          collapsed = _this$props2.collapsed,
          onCollapse = _this$props2.onCollapse,
          isMobile = _this$props2.isMobile,
          menuData = _this$props2.menuData;
      var openKeys = this.state.openKeys; // Don't show popup menu when it is been collapsed

      var menuProps = collapsed ? {} : {
        openKeys: openKeys
      }; // if pathname can't match, use the nearest parent's key

      var selectedKeys = this.getSelectedMenuKeys();

      if (!selectedKeys.length) {
        selectedKeys = [openKeys[openKeys.length - 1]];
      }

      return _react.default.createElement(Sider, {
        trigger: null,
        collapsible: true,
        collapsed: collapsed,
        breakpoint: "lg",
        onCollapse: onCollapse,
        width: 256,
        className: "menu-sider"
      }, _react.default.createElement("div", {
        className: "menu-sider-logo",
        key: "logo"
      }, _react.default.createElement(_ShopList.default, {
        isMobile: isMobile
      })), _react.default.createElement(_menu.default, (0, _extends2.default)({
        key: "Menu",
        theme: "dark",
        mode: "inline"
      }, menuProps, {
        onOpenChange: this.handleOpenChange,
        selectedKeys: selectedKeys,
        style: {
          padding: '16px 0',
          width: '100%'
        }
      }), this.getNavMenuItems(menuData)));
    }
  }]);
  (0, _inherits2.default)(SiderMenu, _React$Component);
  return SiderMenu;
}(_react.default.Component);

exports.default = SiderMenu;