"use strict";

var _pathTools = require("../_utils/pathTools");

var _SiderMenu = require("./SiderMenu");

var menu = [{
  path: '/dashboard',
  children: [{
    path: '/dashboard/name'
  }]
}, {
  path: '/userinfo',
  children: [{
    path: '/userinfo/:id',
    children: [{
      path: '/userinfo/:id/info'
    }]
  }]
}];
var flatMenuKeys = (0, _SiderMenu.getFlatMenuKeys)(menu);
describe('test convert nested menu to flat menu', function () {
  it('simple menu', function () {
    expect(flatMenuKeys).toEqual(['/dashboard', '/dashboard/name', '/userinfo', '/userinfo/:id', '/userinfo/:id/info']);
  });
});
describe('test menu match', function () {
  it('simple path', function () {
    expect((0, _SiderMenu.getMenuMatchKeys)(flatMenuKeys, (0, _pathTools.urlToList)('/dashboard'))).toEqual(['/dashboard']);
  });
  it('error path', function () {
    expect((0, _SiderMenu.getMenuMatchKeys)(flatMenuKeys, (0, _pathTools.urlToList)('/dashboardname'))).toEqual([]);
  });
  it('Secondary path', function () {
    expect((0, _SiderMenu.getMenuMatchKeys)(flatMenuKeys, (0, _pathTools.urlToList)('/dashboard/name'))).toEqual(['/dashboard', '/dashboard/name']);
  });
  it('Parameter path', function () {
    expect((0, _SiderMenu.getMenuMatchKeys)(flatMenuKeys, (0, _pathTools.urlToList)('/userinfo/2144'))).toEqual(['/userinfo', '/userinfo/:id']);
  });
  it('three parameter path', function () {
    expect((0, _SiderMenu.getMenuMatchKeys)(flatMenuKeys, (0, _pathTools.urlToList)('/userinfo/2144/info'))).toEqual(['/userinfo', '/userinfo/:id', '/userinfo/:id/info']);
  });
});