"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _antd = require("antd");

require("./index.module.css");

var CheckableTag = _antd.Tag.CheckableTag;

var TagSelectOption = function TagSelectOption(_ref) {
  var children = _ref.children,
      checked = _ref.checked,
      _onChange = _ref.onChange,
      value = _ref.value;
  return _react.default.createElement(CheckableTag, {
    checked: checked,
    key: value,
    onChange: function onChange(state) {
      return _onChange(value, state);
    }
  }, children);
};

TagSelectOption.isTagSelectOption = true;

var TagSelect =
/*#__PURE__*/
function (_Component) {
  function TagSelect(props) {
    var _this;

    (0, _classCallCheck2.default)(this, TagSelect);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(TagSelect).call(this, props));
    (0, _defineProperty2.default)((0, _defineProperty2.default)((0, _defineProperty2.default)((0, _defineProperty2.default)((0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "onChange", function (value) {
      var onChange = _this.props.onChange;

      if (!('value' in _this.props)) {
        _this.setState({
          value: value
        });
      }

      if (onChange) {
        onChange(value);
      }
    }), "onSelectAll", function (checked) {
      var checkedTags = [];

      if (checked) {
        checkedTags = _this.getAllTags();
      }

      _this.onChange(checkedTags);
    }), "handleTagChange", function (value, checked) {
      var v = _this.state.value;
      var checkedTags = (0, _toConsumableArray2.default)(v);
      var index = checkedTags.indexOf(value);

      if (checked && index === -1) {
        checkedTags.push(value);
      } else if (!checked && index > -1) {
        checkedTags.splice(index, 1);
      }

      _this.onChange(checkedTags);
    }), "handleExpand", function () {
      var expand = _this.state.expand;

      _this.setState({
        expand: !expand
      });
    }), "isTagSelectOption", function (node) {
      return node && node.type && (node.type.isTagSelectOption || node.type.displayName === 'TagSelectOption');
    });
    _this.state = {
      expand: false,
      value: props.value || props.defaultValue || []
    };
    return _this;
  }

  (0, _createClass2.default)(TagSelect, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if ('value' in nextProps && nextProps.value) {
        this.setState({
          value: nextProps.value
        });
      }
    }
  }, {
    key: "getAllTags",
    value: function getAllTags() {
      var _this2 = this;

      var children = this.props.children;
      children = _react.default.Children.toArray(children);
      var checkedTags = children.filter(function (child) {
        return _this2.isTagSelectOption(child);
      }).map(function (child) {
        return child.props.value;
      });
      return checkedTags || [];
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames,
          _this3 = this;

      var _this$state = this.state,
          value = _this$state.value,
          expand = _this$state.expand;
      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          style = _this$props.style,
          expandable = _this$props.expandable;
      var checkedAll = this.getAllTags().length === value.length;
      var cls = (0, _classnames.default)("tagSelect", className, (_classNames = {}, (0, _defineProperty2.default)(_classNames, "hasExpandTag", expandable), (0, _defineProperty2.default)(_classNames, "expanded", expand), _classNames));
      return _react.default.createElement("div", {
        className: cls,
        style: style
      }, _react.default.createElement(CheckableTag, {
        checked: checkedAll,
        key: "tag-select-__all__",
        onChange: this.onSelectAll
      }, "\u5168\u90E8"), value && _react.default.Children.map(children, function (child) {
        if (_this3.isTagSelectOption(child)) {
          return _react.default.cloneElement(child, {
            key: "tag-select-".concat(child.props.value),
            value: child.props.value,
            checked: value.indexOf(child.props.value) > -1,
            onChange: _this3.handleTagChange
          });
        }

        return child;
      }), expandable && _react.default.createElement("a", {
        className: "trigger",
        onClick: this.handleExpand
      }, expand ? '收起' : '展开', " ", _react.default.createElement(_antd.Icon, {
        type: expand ? 'up' : 'down'
      })));
    }
  }]);
  (0, _inherits2.default)(TagSelect, _Component);
  return TagSelect;
}(_react.Component);

TagSelect.Option = TagSelectOption;
var _default = TagSelect;
exports.default = _default;