"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _objectDestructuringEmpty2 = _interopRequireDefault(require("@babel/runtime/helpers/objectDestructuringEmpty"));

var _services = require("./services");

var _router = require("dva/router");

var _utils = require("./router/utils");

var _utils2 = require("../http/utils");

var _default = {
  namespace: 'global',
  state: {
    user: {},
    menus: [],
    shops: []
  },
  subscriptions: {
    setup: function setup(_ref)
    /* dispatch, history */
    {// eslint-disable-line

      (0, _objectDestructuringEmpty2.default)(_ref);
    }
  },
  effects: {
    fetchUser:
    /*#__PURE__*/
    _regenerator.default.mark(function fetchUser(_ref2, _ref3) {
      var payload, call, put, user;
      return _regenerator.default.wrap(function fetchUser$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              payload = _ref2.payload;
              call = _ref3.call, put = _ref3.put;
              _context.next = 4;
              return call(_services.getUserInfo, payload);

            case 4:
              user = _context.sent;
              _context.next = 7;
              return put({
                type: 'set',
                payload: {
                  user: user
                }
              });

            case 7:
            case "end":
              return _context.stop();
          }
        }
      }, fetchUser, this);
    }),
    fetchShop:
    /*#__PURE__*/
    _regenerator.default.mark(function fetchShop(_ref4, _ref5) {
      var payload, call, put, shops;
      return _regenerator.default.wrap(function fetchShop$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              payload = _ref4.payload;
              call = _ref5.call, put = _ref5.put;
              _context2.next = 4;
              return call(_services.getShopInfo, payload);

            case 4:
              shops = _context2.sent;
              _context2.next = 7;
              return put({
                type: 'set',
                payload: {
                  shops: shops
                }
              });

            case 7:
            case "end":
              return _context2.stop();
          }
        }
      }, fetchShop, this);
    }),
    fetchMenu:
    /*#__PURE__*/
    _regenerator.default.mark(function fetchMenu(_ref6, _ref7) {
      var payload, call, put, menus;
      return _regenerator.default.wrap(function fetchMenu$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              payload = _ref6.payload;
              call = _ref7.call, put = _ref7.put;
              _context3.next = 4;
              return call(_services.getMenusInfo, payload);

            case 4:
              menus = _context3.sent;
              _context3.next = 7;
              return put({
                type: 'set',
                payload: {
                  menus: menus
                }
              });

            case 7:
            case "end":
              return _context3.stop();
          }
        }
      }, fetchMenu, this);
    }),
    switch:
    /*#__PURE__*/
    _regenerator.default.mark(function _switch(_ref8, _ref9) {
      var payload, call, put;
      return _regenerator.default.wrap(function _switch$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              payload = _ref8.payload;
              call = _ref9.call, put = _ref9.put;

              if (payload.shopId) {
                localStorage.setItem('shopId', payload.shopId);
              }

              _context4.next = 5;
              return call(_services.switchUserShop, payload);

            case 5:
              _context4.next = 7;
              return put({
                type: 'fetchMenu'
              });

            case 7:
              _context4.next = 9;
              return put({
                type: 'fetchShop'
              });

            case 9:
            case "end":
              return _context4.stop();
          }
        }
      }, _switch, this);
    }),
    logout:
    /*#__PURE__*/
    _regenerator.default.mark(function logout(_, _ref10) {
      var call, put, select, pathname;
      return _regenerator.default.wrap(function logout$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              call = _ref10.call, put = _ref10.put, select = _ref10.select;
              _context5.next = 3;
              return select(function (state) {
                return state.routing.location.pathname;
              });

            case 3:
              pathname = _context5.sent;
              _context5.prev = 4;
              _context5.next = 7;
              return call(_services.logout);

            case 7:
              (0, _utils.removeAuthority)(); // get location pathname

              /* const urlParams = new URL(window.location.href);
              const pathname = yield select(state => state.routing.location.pathname);
              // add the parameters in the url
              urlParams.searchParams.set('redirect', pathname);
              window.history.replaceState(null, 'login', urlParams.href); */

            case 8:
              _context5.prev = 8;

              if (!window.location.host.includes(_utils2.ERP_HOST)) {
                _context5.next = 14;
                break;
              }

              _context5.next = 12;
              return put(_router.routerRedux.push(pathname ? "/user/login?redirect=".concat(pathname) : '/user/login'));

            case 12:
              _context5.next = 15;
              break;

            case 14:
              window.location.href = (0, _utils2.geneLoginUrl)();

            case 15:
              return _context5.finish(8);

            case 16:
            case "end":
              return _context5.stop();
          }
        }
      }, logout, this, [[4,, 8, 16]]);
    })
  },
  reducers: {
    set: function set(state, action) {
      return (0, _objectSpread2.default)({}, state, action.payload);
    }
  }
};
exports.default = _default;