"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getErrorMsg = getErrorMsg;
exports.showErrorMsg = showErrorMsg;
exports.handleUnauthorized = handleUnauthorized;
exports.geneLoginUrl = exports.ERROR_MSG_MAP = exports.MEMBER_UNAUTH = exports.WX_UNAUTH = exports.ERP_UNAUTH = exports.LOGIN_URL = exports.ADMIN_URL = exports.ERP_HOST = void 0;

var _assign = _interopRequireDefault(require("@babel/runtime/core-js/object/assign"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _utils = require("../../utils");

var _message = _interopRequireDefault(require("antd/lib/message"));

var _notification = _interopRequireDefault(require("antd/lib/notification"));

require("antd/lib/message/style/index.css");

require("antd/lib/notification/style/index.css");

var ERP_HOST = 'erp.feewee.cn';
exports.ERP_HOST = ERP_HOST;
var ADMIN_URL = window.location.protocol + "//".concat((0, _utils.getRightEnv)()).concat(ERP_HOST);
exports.ADMIN_URL = ADMIN_URL;
var LOGIN_URL = '/#/user/login';
exports.LOGIN_URL = LOGIN_URL;
var ERP_UNAUTH = 40101;
exports.ERP_UNAUTH = ERP_UNAUTH;
var WX_UNAUTH = 40102;
exports.WX_UNAUTH = WX_UNAUTH;
var MEMBER_UNAUTH = 40103;
exports.MEMBER_UNAUTH = MEMBER_UNAUTH;
var ERROR_MSG_MAP = {
  // on my mind, i recommend to use server response message to show not as following:
  // 40101: '未登录',      //ERP user
  // 40102: '微信未授权',  // wechat user
  // 40103: '您不是会员',  // member user
  401: '抱歉，您还未登录',
  403: '抱歉，您没有权限访问该页面',
  413: '抱歉，您上传文件太大',
  404: '服务器迷路了，未寻到这个地址',
  405: '服务器无法理解这个请求方法',
  500: '服务器开小差，这是一个问题',
  502: '网关服务器在跟你开玩笑呢',
  503: '服务器不可用，你在跟我开玩笑',
  504: '服务器过于拥挤，超时空穿越了'
};
exports.ERROR_MSG_MAP = ERROR_MSG_MAP;

function getErrorMsg(data, status, statusText) {
  var msg = '';

  if ((0, _typeof2.default)(data) !== 'object') {
    msg = ERROR_MSG_MAP[status];
  } else {
    msg = data.result || data.message;
  }

  return msg || statusText || 'Uncaught (in feewee/http)';
}

function showErrorMsg(msg, description) {
  if (description) {
    // 采用 windows chrome 的推送布局 `bottomRight`
    _notification.default.error((0, _assign.default)({
      // placement: 'bottomRight',
      bottom: 50,
      duration: 3
    }, {
      message: msg,
      description: description
    }));
  } else {
    _message.default.error(msg);
  }
}
/**
 * Generates login url with redirect
 * @param {String} queryString  `?a=b&c=d` default: `?redirect=${encodeURIComponent(window.location.href)}`
 * @return loginUrl
 */


var geneLoginUrl = function geneLoginUrl() {
  var queryString = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "?redirect=".concat(encodeURIComponent(window.location.href));
  return "".concat(ADMIN_URL).concat(LOGIN_URL).concat(queryString);
};
/**
 * 控制未授权的内容
 */


exports.geneLoginUrl = geneLoginUrl;

function handleUnauthorized(status, data) {
  if (!data || (0, _typeof2.default)(data) !== 'object' || !('' + data.status)) return;
  var statusCode = data.status;
  showErrorMsg(getErrorMsg(data, status));

  if (statusCode === ERP_UNAUTH) {
    /* if (getRightEnv() === 'dev') {
      console.error('开发环境下，你还未登陆的提示！')
    } else { */
    window.location.href = geneLoginUrl(); // }
  } else if (statusCode === WX_UNAUTH) {// ERP 中理论上而言不会涉及微信的修改
    // go2OAuth(true);
  } else if (statusCode === MEMBER_UNAUTH) {
    // 非会员的处理，ERP中理论上而言也不会涉及非会员的处理
    // loginConfirm(errMsg);
    window.location.href = geneLoginUrl();
  }
}