"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getCookie = getCookie;
exports.hasCookie = hasCookie;
exports.setCookie = setCookie;
exports.delCookie = delCookie;
exports.default = exports.del = exports.set = exports.get = exports.has = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

/**
 * Provide `getter` & `setter` to operate cookies
 */
var cookieCacheStr = '';
var cookie = {};
var has = hasCookie;
exports.has = has;
var get = getCookie;
exports.get = get;
var set = setCookie;
exports.set = set;
var del = delCookie;
exports.del = del;
var _default = {
  get all() {
    return getCookie();
  },

  get: get,
  has: has,
  set: set,
  del: del
  /**
   * getter
   * @param {String} name
   * @Cacheable
   * @return {null | string | object}
   */

};
exports.default = _default;

function getCookie(name) {
  if (cookieCacheStr !== document.cookie) {
    cookie = {};
    document.cookie.split(';').forEach(function (t) {
      var _t$split = t.split('='),
          _t$split2 = (0, _slicedToArray2.default)(_t$split, 2),
          key = _t$split2[0],
          value = _t$split2[1];

      cookie[key.replace(/\s/g, '')] = value;
    });
    cookieCacheStr = document.cookie;
  }

  return name ? cookie[name] : cookie;
}

function hasCookie(key) {
  return !!get(key);
}

;
/**
 * setCookie
 * @setter
 * @param {String} key
 * @param {String} val
 * @param {String} domain
 * @param {String} path
 * @param {GMTDateTime} expiresTime
 */

function setCookie(key, val, domain, path, expiresTime) {
  document.cookie = key + '=' + val + (domain ? ';domain=' + domain : '') + (path ? ';path=' + path : '') + ";expires=".concat(expiresTime ? expiresTime instanceof Date ? expiresTime : new Date(expiresTime).toGMTString() : 'Thu, 01 Jan 1970 00:00:01 GMT');
  return hasCookie(key);
}

function delCookie(key) {
  var url = new URL(window.location.href); // a.b.cn => [a.b.cn, b.cn]

  var paths = url.hostname.split('.');
  var domains = []; // cause the last one of paths always is `cn/com/org/other...`.

  while (paths.length > 1) {
    domains.push(paths.join('.'));
    paths.shift();
  } // loop to delete all cookie in domains one by one


  domains.forEach(function (domain) {
    setCookie(key, '', domain, '/');
  });
  return !hasCookie(key);
}

;