"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

/**
 * Queue
 * @param {Array} arr
 * @property {Boolean} debug
 * @example
 *  import Queue from 'feewee/utils/Queue';
 *  Queue.debug = true;
 *  const queue = new Queue([1, 2, 3])
 *  queue.out(1);
 *  queue.out(4);
 */
var Queue =
/*#__PURE__*/
function () {
  function Queue(arr) {
    (0, _classCallCheck2.default)(this, Queue);
    this.queue = (0, _toConsumableArray2.default)(arr);
    this.debug = debug;
  }

  (0, _createClass2.default)(Queue, [{
    key: "in",
    value: function _in(item) {
      if (Queue.debug) {
        console.log('====================================');
        console.log('queue in: ', item);
        console.log('====================================');
      }

      this.queue.push(item);
      return this;
    }
  }, {
    key: "out",
    value: function out(item) {
      var deleted = null;

      if (item) {
        var index = this.queue.indexOf(item);

        if (index) {
          deleted = this.queue.splice(index, 1)[0];
        }
      } else {
        deleted = this.queue.shift();
      }

      if (Queue.debug) {
        console.log('====================================');
        console.log('queue out: ', deleted);
        console.log('====================================');
      }

      return this;
    }
  }, {
    key: "clear",
    value: function clear() {
      this.queue = [];
      return this;
    }
  }]);
  return Queue;
}();

exports.default = Queue;